readi p,"Input prime p>5";
F:=GF(p);

Z:=Integers();
for i in [2..p-1] do
  a:=F!i;
  vals:={a^k:k in [1..p-1]};
  if #vals eq p-1 then w:=i; break; end if;
end for;

print "p,w equal",p,w;

V1:=VectorSpace(F,1);
V4:=VectorSpace(F,4);
H41:=Hom(V4,V1);
H44:=Hom(V4,V4);

lead:=function(v)
  if v[1] ne 0 then return v[1]^-1*v; end if;
  if v[2] ne 0 then return v[2]^-1*v; end if;
  if v[3] ne 0 then return v[3]^-1*v; end if;
  if v[4] ne 0 then return v[4]^-1*v; end if;
  return v;
end function;

xyzts:=[];
for x in [0,1] do
rangey:=[0..p-1];
if x eq 0 then rangey:=[0,1]; end if;
for y in rangey do
rangez:=[0..p-1];
if x eq 0 and y eq 0 then rangez:=[0,1]; end if;
for z in rangez do
ranget:=[0..p-1];
if x eq 0 and y eq 0 and z eq 0 then ranget:=[1]; end if;
for t in ranget do
  xyzt:=[x,y,z,t];
  v:=V4!xyzt;
  new:=true;
  for a in [0,1] do
  rangeb:=[0..p-1];
  if a eq 0 then rangeb:=[1]; end if;
  for b in rangeb do
    A:=H44![a*(a^2+w*b^2),b*(w*a^2+w^2*b^2),2*w*a^2*b,2*w^2*a*b^2,
            b*(a^2+w*b^2),a*(a^2+w*b^2),2*w*a*b^2,2*w*a^2*b,
            2*a^2*b,2*w*a*b^2,a*(a^2+w*b^2),b*(w*a^2+w^2*b^2),
            2*a*b^2,2*a^2*b,b*(a^2+w*b^2),a*(a^2+w*b^2)];
    A:=Transpose(A);
    v1:=lead(v*A);
    index:=[Z!v1[1],Z!v1[2],Z!v1[3],Z!v1[4]];
    if index lt xyzt then new:=false; break; end if;
    A:=Transpose(A);
    A[2]:=-A[2]; A[3]:=-A[3];
    A:=Transpose(A);
    v1:=lead(v*A);
    index:=[Z!v1[1],Z!v1[2],Z!v1[3],Z!v1[4]];
    if index lt xyzt then new:=false; break; end if;
  end for;
  if not new then break; end if;
  end for;
  if new then Append(~xyzts,xyzt); end if;

end for;
end for;
end for;
end for;

//#xyzts,(p^2+p-GCD(p-1,3)+5)/2;

GS:=[];
u:=Z!(F!(1/w)); bch:=Z!(F!(3/(2*w))); bch2:=Z!(F!(1/(2*w))); half:=(p+1) div 2;
for xyzt in xyzts do
  A:=H41!xyzt;
  K:=Kernel(A);
  xs:=[0,0,0,0];
  for i in [1..4] do
    if V4.i notin K then xs[i]:=1; break; end if;
  end for;
  
  Append(~GS,Group<a,b|a^p,b^p,(b,a,b,b)=(b,a,a,a)^u*(b,a,a,a,a)^-bch*(b,a,a,a,b)^bch*(b,a,a,b,a)^-bch2*(b,a,a,b,b)^half,
                       (b,a,a,a,a)^Z!(K.1)[1]*(b,a,a,a,b)^Z!(K.1)[2]*(b,a,a,b,a)^Z!(K.1)[3]*(b,a,a,b,b)^Z!(K.1)[4],
                       (b,a,a,a,a)^Z!(K.2)[1]*(b,a,a,a,b)^Z!(K.2)[2]*(b,a,a,b,a)^Z!(K.2)[3]*(b,a,a,b,b)^Z!(K.2)[4],
                       (b,a,a,a,a)^Z!(K.3)[1]*(b,a,a,a,b)^Z!(K.3)[2]*(b,a,a,b,a)^Z!(K.3)[3]*(b,a,a,b,b)^Z!(K.3)[4]>);
  Append(~GS,Group<a,b|a^p,b^p,(b,a,b,b)=(b,a,a,a)^u*(b,a,a,a,a)^(xs[1]-bch)*(b,a,a,a,b)^(xs[2]+bch)
                       *(b,a,a,b,a)^(xs[3]-bch2)*(b,a,a,b,b)^(xs[4]+half),
                       (b,a,a,a,a)^Z!(K.1)[1]*(b,a,a,a,b)^Z!(K.1)[2]*(b,a,a,b,a)^Z!(K.1)[3]*(b,a,a,b,b)^Z!(K.1)[4],
                       (b,a,a,a,a)^Z!(K.2)[1]*(b,a,a,a,b)^Z!(K.2)[2]*(b,a,a,b,a)^Z!(K.2)[3]*(b,a,a,b,b)^Z!(K.2)[4],
                       (b,a,a,a,a)^Z!(K.3)[1]*(b,a,a,a,b)^Z!(K.3)[2]*(b,a,a,b,a)^Z!(K.3)[3]*(b,a,a,b,b)^Z!(K.3)[4]>);
end for;


PS:=[];
for G in GS do
  P:=pQuotient(G,p,5);
  Append(~PS,P);
end for;

"Sequence PS contains",#PS,"groups of order p^8";


