readi p,"Input prime p>7";
F:=GF(p);

Z:=Integers();
for i in [2..p-1] do
  a:=F!i;
  vals:={a^k:k in [1..p-1]};
  if #vals eq p-1 then w:=i; break; end if;
end for;

print "p,w equal",p,w;


bch:=Z!(F!(w+17/12)); bch2:=Z!(F!(-2*w-11/6));
GS:=[
Group<a,b|a^p,b^p,(b,a,a)=(b,a,b,b)*(b,a,b,b,b)^-1*(b,a,b,b,b,b)^bch*(b,a,b,b,b,b,b)^bch2,
          (b,a,b,b,a)=(b,a,b,b,b,b)*(b,a,b,b,b,b,b)^(y-1)>:y in [1..(p-1) div 2]] cat [
Group<a,b|a^p,b^p,(b,a,a)=(b,a,b,b)*(b,a,b,b,b)^-1*(b,a,b,b,b,b)^bch*(b,a,b,b,b,b,b)^(x+bch2),
          (b,a,b,b,a)=(b,a,b,b,b,b)*(b,a,b,b,b,b,b)^-1>:x in [0..(p-1) div 2]];

counts:=[];
PS:=[];
for G in GS do
  P:=pQuotient(G,p,7);
  P:=StandardPresentation(P:StartClass:=7);
  if Order(P) ne p^8 then print "Wrong order!"; readi zzz; end if;
  Append(~PS,P);
  a,b:=SmallGroupEncoding(P);
  Append(~counts,a);
  a;

end for;
#counts,#Seqset(counts);

for i in [1..#counts-1] do
for j in [i+1..#counts] do
  if counts[i] eq counts[j] then print i,j; end if;
end for;
end for;


G:=Group<a,b|a^p,b^p,(b,a,a)=(b,a,b,b)*(b,a,b,b,b)^-1*(b,a,b,b,b,b)^bch,(b,a,b,b,a)=(b,a,b,b,b,b)>;
P:=pQuotient(G,p,6);
P;
D:=Descendants(P:StepSizes:=[1],Exponent:=p);
#D,p;

bees:={};
for P in D do
  a,b:=SmallGroupEncoding(P);
  Include(~bees,a);
end for;

bees eq Seqset(counts);

